Index: java/main/src/main/java/com/framsticks/params/types/NumberParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 99)
@@ -2,5 +2,4 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.params.Flags;
 import com.framsticks.params.ParamBuilder;
 import com.framsticks.params.PrimitiveParam;
@@ -10,4 +9,5 @@
 
 import javax.annotation.concurrent.Immutable;
+import static com.framsticks.params.SetStateFlags.*;
 
 /**
@@ -40,8 +40,8 @@
 		}
 		if (min != null && v.compareTo(getMin(type)) < 0) {
-			return new ReassignResult<T>(getMin(type), Flags.PSET_HITMIN);
+			return new ReassignResult<T>(getMin(type), PSET_HITMIN);
 		}
 		if (max != null && v.compareTo(getMax(type)) > 0) {
-			return new ReassignResult<T>(getMax(type), Flags.PSET_HITMAX);
+			return new ReassignResult<T>(getMax(type), PSET_HITMAX);
 		}
 		return ReassignResult.create(v);
Index: java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 99)
@@ -54,5 +54,5 @@
 	@Override
 	public Class<?> getStorageType() {
-		return Void.class;
+		return Void.TYPE;
 	}
 
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 99)
@@ -14,5 +14,4 @@
 import static com.framsticks.params.SimpleAbstractAccess.*;
 
-import com.framsticks.params.Flags;
 import com.framsticks.params.Param;
 import com.framsticks.params.PrimitiveParam;
@@ -26,4 +25,6 @@
 import com.framsticks.params.FramsClass;
 import com.framsticks.params.AccessInterface;
+import static com.framsticks.params.ParamFlags.*;
+import static com.framsticks.params.SetStateFlags.*;
 
 /**
@@ -205,5 +206,5 @@
 					}
 				} else {
-					if (nextParamNumber == null || ((params[nextParamNumber].getFlags() & Flags.CANOMITNAME) == 0)) {
+					if (nextParamNumber == null || ((params[nextParamNumber].getFlags() & CANOMITNAME) == 0)) {
 						nextParamNumber = null;
 						throw new Exception(
@@ -220,13 +221,13 @@
 						PrimitiveParam<?> vp = (PrimitiveParam<?>) currentParam;
 						int setFlag = access.set(vp, pair.value);
-						if ((setFlag & Flags.PSET_HITMIN) != 0) {
-							exceptions.add(createBoundaryHitException(access, vp, pair.value, Flags.PSET_HITMIN));
-						}
-
-						if ((setFlag & Flags.PSET_HITMAX) != 0) {
-							exceptions.add(createBoundaryHitException(access, vp, pair.value, Flags.PSET_HITMAX));
-						}
-
-						if ((setFlag & Flags.PSET_RONLY) != 0) {
+						if ((setFlag & PSET_HITMIN) != 0) {
+							exceptions.add(createBoundaryHitException(access, vp, pair.value, PSET_HITMIN));
+						}
+
+						if ((setFlag & PSET_HITMAX) != 0) {
+							exceptions.add(createBoundaryHitException(access, vp, pair.value, PSET_HITMAX));
+						}
+
+						if ((setFlag & PSET_RONLY) != 0) {
 							throw (new Exception("tried to set a read-only attribute \""
 								+ currentParam.getId()
@@ -250,5 +251,5 @@
 
 	private static Exception createBoundaryHitException(AccessInterface access, PrimitiveParam<?> param, String value, int flag) {
-		boolean minimum = (flag & Flags.PSET_HITMIN) != 0;
+		boolean minimum = (flag & PSET_HITMIN) != 0;
 		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
 		String name =  (minimum ? "minimum" : "maximum");
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 99)
@@ -7,4 +7,5 @@
 import com.framsticks.util.lang.Containers;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
+import static com.framsticks.params.ParamFlags.*;
 
 /**
@@ -65,5 +66,5 @@
 			}
 
-			if ((!contiguous) || ((param.getFlags() & Flags.CANOMITNAME) == 0)) {
+			if ((!contiguous) || ((param.getFlags() & CANOMITNAME) == 0)) {
 				line.append(param.getId()).append("=");
 				contiguous = true;
Index: java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/parsers/GenotypeLoader.java	(revision 99)
@@ -6,4 +6,5 @@
 
 import org.apache.log4j.Logger;
+import static com.framsticks.params.ParamFlags.*;
 
 public class GenotypeLoader extends MultiParamLoader {
@@ -24,18 +25,18 @@
 			.param(Param.build().id("genotype").group(0).name("Genotype").type(StringParam.class).min(1))
 			.param(Param.build().id("info").group(0).name("Info").type(StringParam.class).min(1).help("Additional information or comments"))
-			.param(Param.build().id("simi").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Similarity").type(FloatParam.class))
-			.param(Param.build().id("energ0").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Starting energy").type(FloatParam.class))
-			.param(Param.build().id("strsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body parts (deprecated; use numparts)").type(FloatParam.class))
-			.param(Param.build().id("strjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Body joints (deprecated; use numjoints)").type(FloatParam.class))
-			.param(Param.build().id("nnsiz").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain size (deprecated; use numneurons)").type(FloatParam.class))
-			.param(Param.build().id("nncon").group(1).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Brain connections (deprecated; use numconnections)").type(FloatParam.class))
-			.param(Param.build().id("numparts").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body parts").type(FloatParam.class))
-			.param(Param.build().id("numjoints").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Body joints").type(FloatParam.class))
-			.param(Param.build().id("numneurons").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain size").type(FloatParam.class))
-			.param(Param.build().id("numconnections").group(1).flags(Flags.READONLY | Flags.DONTSAVE).name("Brain connections").type(FloatParam.class))
+			.param(Param.build().id("simi").group(1).flags(READONLY | DONTSAVE).name("Similarity").type(FloatParam.class))
+			.param(Param.build().id("energ0").group(1).flags(READONLY | DONTSAVE).name("Starting energy").type(FloatParam.class))
+			.param(Param.build().id("strsiz").group(1).flags(READONLY | DONTSAVE | USERHIDDEN).name("Body parts (deprecated; use numparts)").type(FloatParam.class))
+			.param(Param.build().id("strjoints").group(1).flags(READONLY | DONTSAVE | USERHIDDEN).name("Body joints (deprecated; use numjoints)").type(FloatParam.class))
+			.param(Param.build().id("nnsiz").group(1).flags(READONLY | DONTSAVE | USERHIDDEN).name("Brain size (deprecated; use numneurons)").type(FloatParam.class))
+			.param(Param.build().id("nncon").group(1).flags(READONLY | DONTSAVE | USERHIDDEN).name("Brain connections (deprecated; use numconnections)").type(FloatParam.class))
+			.param(Param.build().id("numparts").group(1).flags(READONLY | DONTSAVE).name("Body parts").type(FloatParam.class))
+			.param(Param.build().id("numjoints").group(1).flags(READONLY | DONTSAVE).name("Body joints").type(FloatParam.class))
+			.param(Param.build().id("numneurons").group(1).flags(READONLY | DONTSAVE).name("Brain size").type(FloatParam.class))
+			.param(Param.build().id("numconnections").group(1).flags(READONLY | DONTSAVE).name("Brain connections").type(FloatParam.class))
 			.param(Param.build().id("num").group(2).name("Ordinal number").type(DecimalParam.class))
 			.param(Param.build().id("gnum").group(2).name("Generation").type(DecimalParam.class))
-			.param(Param.build().id("popsiz").group(2).flags(Flags.USERHIDDEN).name("Deprecated; use entities").type(DecimalParam.class))
-			.param(Param.build().id("entities").group(2).flags(Flags.DONTSAVE).name("Instances").type(DecimalParam.class).help("Copies of this genotype"))
+			.param(Param.build().id("popsiz").group(2).flags(USERHIDDEN).name("Deprecated; use entities").type(DecimalParam.class))
+			.param(Param.build().id("entities").group(2).flags(DONTSAVE).name("Instances").type(DecimalParam.class).help("Copies of this genotype"))
 			.param(Param.build().id("lifespan").group(2).name("Life span").type(FloatParam.class).help("Average life span"))
 			.param(Param.build().id("velocity").group(2).name("Velocity").type(FloatParam.class).help("Average velocity"))
@@ -43,12 +44,12 @@
 			.param(Param.build().id("vertvel").group(2).name("Vertical velocity").type(FloatParam.class))
 			.param(Param.build().id("vertpos").group(2).name("Vertical position").type(FloatParam.class))
-			.param(Param.build().id("fit").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Fitness").type(FloatParam.class))
-			.param(Param.build().id("fit2").group(3).flags(Flags.READONLY | Flags.DONTSAVE).name("Final fitness").type(FloatParam.class).help("Fitness shifted by (avg-n*stddev)"))
-			.param(Param.build().id("f0genotype").group(4).flags(Flags.READONLY | Flags.DONTSAVE).name("f0 genotype").type(StringParam.class).min(1).help("converted to f0 genotype"))
+			.param(Param.build().id("fit").group(3).flags(READONLY | DONTSAVE).name("Fitness").type(FloatParam.class))
+			.param(Param.build().id("fit2").group(3).flags(READONLY | DONTSAVE).name("Final fitness").type(FloatParam.class).help("Fitness shifted by (avg-n*stddev)"))
+			.param(Param.build().id("f0genotype").group(4).flags(READONLY | DONTSAVE).name("f0 genotype").type(StringParam.class).min(1).help("converted to f0 genotype"))
 			.param(Param.build().id("user1").group(2).name("User field 1").type(UniversalParam.class))
 			.param(Param.build().id("user2").group(2).name("User field 2").type(UniversalParam.class))
 			.param(Param.build().id("user3").group(2).name("User field 3").type(UniversalParam.class))
-			.param(Param.build().id("isValid").group(0).flags(Flags.READONLY | Flags.DONTSAVE | Flags.USERHIDDEN).name("Valid").type(DecimalParam.class).min(0).max(1))
-			.param(Param.build().id("uid").group(0).flags(Flags.READONLY | Flags.USERHIDDEN).name("#").type("s").help("Unique identifier"))
+			.param(Param.build().id("isValid").group(0).flags(READONLY | DONTSAVE | USERHIDDEN).name("Valid").type(DecimalParam.class).min(0).max(1))
+			.param(Param.build().id("uid").group(0).flags(READONLY | USERHIDDEN).name("#").type("s").help("Unique identifier"))
 			.finish();
 
Index: java/main/src/main/java/com/framsticks/parsers/XmlLoader.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/parsers/XmlLoader.java	(revision 99)
@@ -19,4 +19,5 @@
 import com.framsticks.util.AutoBuilder;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.lang.Strings;
 
 public class XmlLoader {
@@ -47,9 +48,14 @@
 	}
 
+	public String mangleName(String name) {
+		return useLowerCase ? name.toLowerCase() : name;
+	}
+
+	public String mangleAttribute(String name) {
+		return useLowerCase ? name.toLowerCase() : Strings.uncapitalize(name);
+	}
+
 	public Object processElement(Element element) {
-		String name = element.getNodeName();
-		if (useLowerCase) {
-			name = name.toLowerCase();
-		}
+		final String name = mangleName(element.getNodeName());
 		if (name.equals("import")) {
 			String className = element.getAttribute("class");
@@ -71,5 +77,5 @@
 		for (int i = 0; i < attributes.getLength(); ++i) {
 			Node attributeNode = attributes.item(i);
-			access.set(attributeNode.getNodeName().toLowerCase(), attributeNode.getNodeValue());
+			access.set(mangleAttribute(attributeNode.getNodeName()), attributeNode.getNodeValue());
 		}
 
Index: java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/remote/RecursiveFetcher.java	(revision 99)
@@ -3,5 +3,4 @@
 import static com.framsticks.core.TreeOperations.*;
 
-import com.framsticks.core.Mode;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
@@ -67,5 +66,5 @@
 				}
 				++dispatched;
-				tree.get(childPath, Mode.FETCH, new FutureHandler<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
+				tree.get(childPath, new FutureHandler<Path>(Logging.logger(log, "resolve", RecursiveFetcher.this)) {
 					@Override
 					protected void result(Path result) {
@@ -83,5 +82,5 @@
 
 	protected void fetch(final Path path) {
-		tree.get(path, Mode.FETCH, new Future<Path>() {
+		tree.get(path, new Future<Path>() {
 
 			@Override
Index: java/main/src/main/java/com/framsticks/remote/RemoteTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/remote/RemoteTree.java	(revision 99)
@@ -7,8 +7,7 @@
 import com.framsticks.communication.queries.SetRequest;
 import com.framsticks.core.AbstractTree;
-import com.framsticks.core.Mode;
-import com.framsticks.core.ListChange;
 import com.framsticks.core.Path;
 import com.framsticks.params.*;
+import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
@@ -28,5 +27,4 @@
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 import com.framsticks.util.lang.Casting;
-import com.framsticks.util.lang.Pair;
 import com.framsticks.util.dispatching.RunAt;
 import static com.framsticks.core.TreeOperations.*;
@@ -42,20 +40,9 @@
  */
 @FramsClassAnnotation
-public class RemoteTree extends AbstractTree implements JoinableParent {
+public final class RemoteTree extends AbstractTree implements JoinableParent {
 
 	private final static Logger log = Logger.getLogger(RemoteTree.class);
 
 	protected ClientSideManagedConnection connection;
-
-	protected final Set<Pair<Path, Subscription<?>>> subscriptions = new HashSet<>();
-
-	public Pair<Path, Subscription<?>> getSubscription(Path path) {
-		for (Pair<Path, Subscription<?>> s : subscriptions) {
-			if (s.first.isTheSameObjects(path)) {
-				return s;
-			}
-		}
-		return null;
-	}
 
 	public RemoteTree() {
@@ -88,5 +75,5 @@
 
 	@Override
-	public void get(final Path path, final ValueParam param, Mode mode, final Future<Object> future) {
+	public void get(final Path path, final ValueParam param, final Future<Object> future) {
 		assert isActive();
 		assert param != null;
@@ -166,5 +153,5 @@
 
 	@Override
-	public void get(final Path path, final Mode mode, final Future<Path> future) {
+	public void get(final Path path, final Future<Path> future) {
 		assert isActive();
 
@@ -187,119 +174,4 @@
 	}
 
-
-	@Override
-	protected void tryRegisterOnChangeEvents(final Path path) {
-		assert isActive();
-		AccessInterface access = bindAccess(path);
-		if (!(access instanceof ListAccess)) {
-			return;
-		}
-
-		assert path.size() >= 2;
-		FramsClass underFramsClass = getInfoFromCache(path.getUnder().getParam().getContainedTypeName());
-
-		EventParam changedEvent;
-		try {
-			changedEvent = underFramsClass.getParamEntry(path.getTop().getParam().getId() + "_changed", EventParam.class);
-		} catch (FramsticksException e) {
-			return;
-		}
-
-		log.debug("registering for " + changedEvent);
-		if (getSubscription(path) != null) {
-			return;
-		}
-
-		final Pair<Path, Subscription<?>> temporary = new Pair<>(path, null);
-		subscriptions.add(temporary);
-
-		connection.subscribe(path.getTextual() + "_changed", this, new SubscriptionCallback<Tree>() {
-			@Override
-			public EventCallback subscribed(final Subscription<? super Tree> subscription) {
-				if (subscription == null) {
-					log.error("failed to subscribe for change event for " + path);
-					return null;
-				}
-				log.debug("subscribed for change event for " + path);
-				// subscription.setDispatcher(RemoteInstance.this);
-				RemoteTree.this.dispatch(new RunAt<Tree>(this) {
-					@Override
-					protected void runAt() {
-						subscriptions.remove(temporary);
-						subscriptions.add(new Pair<Path, Subscription<?>>(path, subscription));
-					}
-				});
-				return new EventCallback() {
-					@Override
-					public void call(List<File> files) {
-						assert isActive();
-						assert files.size() == 1;
-						final MultiParamLoader loader = new MultiParamLoader();
-						loader.setNewSource(files.get(0).getContent());
-						loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
-						loader.addListener(MultiParamLoader.Status.OnComment, new MultiParamLoader.StatusListener() {
-
-							@Override
-							public void onStatusChange() {
-								throw new FramsticksException().msg("multi param loader error").arg("line", loader.getCurrentLine());
-							}
-						});
-						ReflectionAccess access = new ReflectionAccess(ListChange.class, FramsClass.build().forClass(ListChange.class));
-						loader.addAccessInterface(access);
-
-						MultiParamLoader.Status status;
-						while ((status = loader.go()) != MultiParamLoader.Status.Finished) {
-							if (status == MultiParamLoader.Status.AfterObject) {
-								AccessInterface accessInterface = loader.getLastAccessInterface();
-								reactToChange(path, (ListChange) accessInterface.getSelected());
-							}
-						}
-					}
-				};
-			}
-		});
-	}
-
-	protected Future<Path> futureListChanger(final ListChange listChange, final String path) {
-		return new FutureHandler<Path>(Logging.logger(log, "failed to " + listChange, path)) {
-			@Override
-			protected void result(Path result) {
-				log.debug(listChange + ": " + result);
-			}
-		};
-	}
-
-	protected void reactToChange(final Path path, final ListChange listChange) {
-		assert isActive();
-		log.debug("reacting to change " + listChange + " in " + path);
-		AccessInterface access = bindAccess(path);
-		assert access != null;
-
-		if ((listChange.getAction() == ListChange.Action.Modify) && (listChange.getPosition() == -1)) {
-			final String p = path.getTextual();
-			tryGet(this, p, futureListChanger(listChange, p));
-			return;
-		}
-
-		CompositeParam childParam = Casting.tryCast(CompositeParam.class, access.getParam(listChange.getBestIdentifier()));
-		assert childParam != null;
-		switch (listChange.getAction()) {
-			case Add: {
-				final String p = path.getTextual() + "/" + childParam.getId();
-				tryGet(this, p, futureListChanger(listChange, p));
-				break;
-			}
-			case Remove: {
-				access.set(childParam, null);
-				break;
-			}
-			case Modify: {
-				final String p = path.getTextual() + "/" + childParam.getId();
-				tryGet(this, p, futureListChanger(listChange, p));
-				break;
-			}
-		}
-	}
-
 	@Override
 	public void set(final Path path, final PrimitiveParam<?> param, final Object value, final Future<Integer> future) {
@@ -380,26 +252,57 @@
 	}
 
-	// @Override
-	// public Path create(Path path) {
-	//	assert isActive();
-	//	assert !path.isResolved();
-	//	Path resolved = path.tryFindResolution();
-	//	if (!resolved.isResolved()) {
-	//		log.debug("creating: " + path);
-	//		//TODO: access parent here, check if it is valid, only then create
-	//		AccessInterface access = registry.prepareAccess(path.getTop().getParam());
-	//		assert access != null;
-	//		Object child = access.createAccessee();
-	//		assert child != null;
-	//		if (path.size() == 1) {
-	//			setRoot(new Node(getRoot().getParam(), child));
-	//		} else {
-	//			bindAccess(this, path.getUnder()).set(path.getTop().getParam(), child);
-	//		}
-	//		resolved = path.appendResolution(child);
-	//	}
-	//	tryRegisterOnChangeEvents(resolved);
-	//	return resolved;
-	// }
+	protected final Map<EventListener<?>, EventListener<File>> proxyListeners = new IdentityHashMap<>();
+
+	public <A> void addListener(Path path, EventParam param, final EventListener<A> listener, final Class<A> argumentType, final Future<Void> future) {
+		assert isActive();
+		assert path.isResolved();
+		if ((!argumentType.equals(Object.class)) && (null == registry.getFramsClassForJavaClass(argumentType))) {
+			registry.registerAndBuild(argumentType);
+		}
+
+		final EventListener<File> proxyListener = new EventListener<File>() {
+
+			@Override
+			public void action(final File file) {
+				Dispatching.dispatchIfNotActive(RemoteTree.this, new RunAt<RemoteTree>(RemoteTree.this) {
+
+					@Override
+					protected void runAt() {
+						assert isActive();
+						if (argumentType.equals(Object.class)) {
+							listener.action(Casting.tryCast(argumentType, file));
+							return;
+						}
+						AccessInterface access = registry.createAccess(argumentType);
+						Object argument = access.createAccessee();
+						access.select(argument);
+						if (!argumentType.isInstance(argument)) {
+							throw new FramsticksException().msg("created argument is of wrond type").arg("expected", argumentType).arg("created", argument.getClass());
+						}
+						A typedArgument = argumentType.cast(argument);
+
+						// log.info("executing event with argument " + argumentType);
+						MultiParamLoader loader = new MultiParamLoader();
+						loader.setNewSource(file.getContent());
+						loader.addBreakCondition(MultiParamLoader.Status.AfterObject);
+						loader.addAccessInterface(access);
+						loader.go();
+
+						listener.action(typedArgument);
+					}
+				});
+			}
+		};
+
+		proxyListeners.put(listener, proxyListener);
+
+		connection.addListener(Path.appendString(path.getTextual(), param.getId()), proxyListener, this, future);
+	}
+
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, Future<Void> future) {
+		assert isActive();
+		EventListener<File> proxyListener = proxyListeners.get(listener);
+		connection.removeListener(proxyListener, this, future);
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/test/ChangeEvent.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/ChangeEvent.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/test/ChangeEvent.java	(revision 99)
@@ -0,0 +1,17 @@
+package com.framsticks.test;
+
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+
+@FramsClassAnnotation
+public class ChangeEvent {
+
+	@ParamAnnotation
+	public String history;
+
+	@Override
+	public String toString() {
+		return "[test change event: " + history + "]";
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/test/TestClass.java
===================================================================
--- java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/test/TestClass.java	(revision 99)
@@ -1,11 +1,15 @@
 package com.framsticks.test;
+
+import java.util.LinkedList;
+import java.util.List;
 
 import org.apache.log4j.Logger;
 
+import com.framsticks.params.EventListener;
 import com.framsticks.params.annotations.FramsClassAnnotation;
 import com.framsticks.params.annotations.ParamAnnotation;
 import com.framsticks.params.types.ProcedureParam;
 
-@FramsClassAnnotation(order = {"name", "history", "appendHistory", "resetHistory"})
+@FramsClassAnnotation(order = {"name", "history", "history_changed", "appendHistory", "resetHistory"}, register = {ChangeEvent.class})
 public class TestClass {
 	private static final Logger log =
@@ -15,4 +19,5 @@
 	protected String name = "test";
 	protected String history = "initial|";
+	protected final List<EventListener<ChangeEvent>> historyListeners = new LinkedList<>();
 
 	/**
@@ -52,4 +57,5 @@
 		log.debug("appending '" + line + "'");
 		history = history + line + "|";
+		fireHistoryChange();
 		return history.length();
 	}
@@ -59,4 +65,28 @@
 		log.debug("reseting");
 		history = "";
+		fireHistoryChange();
+	}
+
+	protected void fireHistoryChange() {
+		for (EventListener<ChangeEvent> l : historyListeners) {
+			ChangeEvent event = new ChangeEvent();
+			event.history = history;
+			l.action(event);
+		}
+	}
+
+	@ParamAnnotation(id = "history_changed")
+	public void addHistoryListener(EventListener<ChangeEvent> listener) {
+		historyListeners.add(listener);
+	}
+
+	@ParamAnnotation(id = "history_changed")
+	public void removeHistoryListener(EventListener<ChangeEvent> listener) {
+		historyListeners.remove(listener);
+	}
+
+	@Override
+	public String toString() {
+		return "test class " + history;
 	}
 
Index: java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/util/dispatching/AtOnceDispatcher.java	(revision 99)
@@ -5,5 +5,5 @@
  * @author Piotr Sniegowski
  */
-public class AtOnceDispatcher<C> implements Dispatcher<C> {
+public class AtOnceDispatcher<C> extends AbstractJoinable implements JoinableDispatcher<C> {
 
 	@SuppressWarnings("rawtypes")
@@ -25,3 +25,28 @@
 	}
 
+	@Override
+	public String getName() {
+		return "atonce";
+	}
+
+	@Override
+	protected void joinableStart() {
+
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		finish();
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Dispatching.java	(revision 99)
@@ -224,10 +224,12 @@
 
 		protected final double timeOut;
+		protected final ExceptionResultHandler handler;
 
 		/**
 		 * @param timeOut
 		 */
-		public Waiter(double timeOut) {
+		public Waiter(double timeOut, ExceptionResultHandler handler) {
 			this.timeOut = timeOut;
+			this.handler = handler;
 		}
 
@@ -247,6 +249,15 @@
 			}
 			if (!done) {
-				throw new FramsticksException().msg("waiter timed out");
-			}
+				handler.handle(new FramsticksException().msg("waiter timed out"));
+			}
+		}
+
+		public <T> Future<T> passInFuture(Class<T> type) {
+			return new FutureHandler<T>(handler) {
+				@Override
+				protected void result(T result) {
+					Waiter.this.pass();
+				}
+			};
 		}
 	}
@@ -254,5 +265,5 @@
 
 	public static <C> void synchronize(Dispatcher<C> dispatcher, double seconds) {
-		final Waiter waiter = new Waiter(seconds);
+		final Waiter waiter = new Waiter(seconds, ThrowExceptionHandler.getInstance());
 		dispatcher.dispatch(new RunAt<C>(ThrowExceptionHandler.getInstance()) {
 			@Override
Index: java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/util/dispatching/FutureHandler.java	(revision 99)
@@ -17,3 +17,13 @@
 	}
 
+	public static <T> FutureHandler<T> doNothing(Class<T> type, ExceptionResultHandler handler) {
+		return new FutureHandler<T>(handler) {
+
+			@Override
+			protected void result(T result) {
+
+			}
+		};
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/dispatching/IgnoreExceptionHandler.java	(revision 99)
@@ -0,0 +1,23 @@
+package com.framsticks.util.dispatching;
+
+import com.framsticks.util.FramsticksException;
+
+public class IgnoreExceptionHandler implements ExceptionResultHandler {
+
+	private static final IgnoreExceptionHandler instance = new IgnoreExceptionHandler();
+
+	private IgnoreExceptionHandler() {
+	}
+
+	@Override
+	public final void handle(FramsticksException exception) {
+	}
+
+	/**
+	 * @return the instance
+	 */
+	public static IgnoreExceptionHandler getInstance() {
+		return instance;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/util/dispatching/Thread.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/util/dispatching/Thread.java	(revision 99)
@@ -73,5 +73,5 @@
 			}
 			try {
-				task.runAt();
+				task.run();
 			} catch (Exception e) {
 				if (exceptionHandler != null) {
@@ -122,5 +122,5 @@
 				@Override
 				protected void runAt() {
-					runnable.runAt();
+					runnable.run();
 				}
 			});
Index: java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java	(revision 99)
+++ java/main/src/main/java/com/framsticks/util/lang/FlagsUtil.java	(revision 99)
@@ -0,0 +1,51 @@
+package com.framsticks.util.lang;
+
+import java.lang.reflect.Field;
+import org.apache.log4j.Logger;
+
+import com.framsticks.util.lang.Delimeted;
+
+public final class FlagsUtil {
+
+	private final static Logger log = Logger.getLogger(FlagsUtil.class);
+
+	private FlagsUtil() {
+	}
+
+	public static String write(Class<?> flagsClass, int flags, String empty) {
+		Delimeted<String> d = new Delimeted<String>("+", empty);
+		try {
+			for (Field f : flagsClass.getDeclaredFields()) {
+				if (f.getType() != int.class) {
+					continue;
+				}
+				if ((flags & f.getInt(null)) != 0) {
+					d.append(f.getName());
+				}
+			}
+		} catch (IllegalArgumentException | IllegalAccessException e) {
+			e.printStackTrace();
+		}
+		return d.build();
+	}
+
+	public static Integer read(Class<?> flagsClass, String flags) {
+		Integer allFlags = 0;
+		String[] flagsSplitted = flags.split("\\+");
+		for (String flag : flagsSplitted) {
+			try {
+				allFlags |= Integer.valueOf(flag);
+			} catch (NumberFormatException ex) {
+				try {
+					Field field = flagsClass.getDeclaredField(flag.toUpperCase());
+					allFlags |= Integer.parseInt(field.get(null).toString());
+				} catch (SecurityException e) {
+					log.warn("security exception was thrown while trying to read flag (" + flag + ")");
+				} catch (NoSuchFieldException | IllegalArgumentException | IllegalAccessException e) {
+					log.warn("selected flag is not known (" + flag + ")");
+				}
+			}
+		}
+		return allFlags;
+	}
+}
Index: java/main/src/main/java/com/framsticks/util/lang/Strings.java
===================================================================
--- java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 98)
+++ java/main/src/main/java/com/framsticks/util/lang/Strings.java	(revision 99)
@@ -36,4 +36,12 @@
 	}
 
+	public static String toStringEmptyProof(Object object, Object def) {
+		if (object == null) {
+			return def.toString();
+		}
+		String v = object.toString();
+		return notEmpty(v) ? v : def.toString();
+	}
+
 	public static String collapse(String s) {
 		if (s == null) {
